/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: AVR465.c
* ߲		: IAR EWAAVR .21A
* 			: $Revision: 1803 $
* t			: $Date: 2007N514() 20:39:10 +0530 (Mon, 14 May 2007) $
* URL		: $URL: http://norsvn01.norway.atmel.com/apps/appsavr/avr465_energy_meter/trunk/code/ATmega169/AVR465.c $
*
* xҰ		: avr@atmel.com
*
* x޲	: ̗ATmega169pɏĂ܂Bɂ̧ѳ16K
*				  ޲Ăׯ̂ǂAVRɂł傤B
*
* pLq		: AVR465:otPd/ٷްv
*
* 			: ̧
*
*
* 쌠 (c) 2006, Atmel Corporation S\ς
*
* ύXL܂͖ſ޲؂̌`ł̍ĔzzƎgp͈ȉ̏ɍv
* ɋ܂B
*
* 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
*	 Ȃ΂Ȃ܂B
*
* 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
*	 ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
*
* 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
*	 (ۏ)ɎgpłȂ܂B
*
* ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
* ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
* mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
* ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
* fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
* RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
* Ȃł傤B
****************************************************************************/

/// ڍ: ///////////////////////////////////////////////////////////////////
//
//  .............................. Kim Meyer, Atmel Finland Design Center
//  ߲...................................... IAR Embedded Workbench 3.10C
//  ߌ`(ׯ/SRAM/EEPROM)...................... ATmega88 (8kB/1kB/512B)
//  ۸ь`......................................................... p
//  ۯg................................................... 4.000000MHz
//
//  "J"pۼުĔCӑI:
//    General-Target-Processor Configuration........................ ATmega88
//    General-Target-Memory Model...................................... Small
//    General-Library Configuration-Enable bit definitions................ ON
//    General-Library Configuration-printf formater..................... Full
//    General-System Configuration-Data stack-Size..................... 0x0F0
//    General-System Configuration-Return address stack-Size.............. 24
//    ICCAVR-Optimisations........................................ Size, High
//    ICCAVR-Optimisations-Enabled-Common subexpression elimination....... NO
//    ICCAVR-Optimisations-Enabled-Function inlining...................... NO
//    ICCAVR-Optimisations-Enabled-Code motion........................... YES
//    ICCAVR-Optimisations-Enabled-Cross call............................ YES
//    ICCAVR-Optimisations-Enabled-Clustering of variables................ NO
//
//  "J"p؎gp:
//
///////////////////////////////////// Ȃ̊b̑SĂ͉Xɑ܂B //


/////////////////////////////////////////////////////////////////////////////
//  ݸٰ
/////////////////////////////////////////////////////////////////////////////

#include <ioavr.h>
#include <stdio.h>
#include <math.h>			// ͕vZł悤ɂ邽߂łB
#include <inavr.h>			// EEPROMٰݗpłB
#include "defines.c"		// `
#include "AVR465.h"
#include "LCD.h"


/////////////////////////////////////////////////////////////////////////////
//  Sϐ
/////////////////////////////////////////////////////////////////////////////

struct	AccDataStructure	{ signed long PL, PN, U2, IL2, IN2;
							} Accumulator, Sum;
struct	ResultDataStructure	{ float PL, PN, U, IL, IN;
							  char ADC0_Gain, ADC1_Gain;
							} Result;
struct	CalDataStructure	{ unsigned int PCC[3];
							  float ILG[3], ING[3];
							  float UG;
							  unsigned int MC, DPC;
							} CalCoeff={{0,24576,49152},
										{0.01,0.001,0.0002},
										{0.01,0.001,0.0002},
										 0.2,10000,100};
struct	SampleStructure		{
							 signed int Fresh, Previous;
							 signed long Filtered,PreviousFiltered,Calibrated;
							} Sample[3];

signed long		Temp[5];
unsigned int	TC1ext,TC1extTOP,TC1extRem;
unsigned int	DisplayCounter,DPCActive,DPCIncrement;
unsigned int	GainHysteresis;
unsigned char	Index,ADC0_Gain=0xFF,ADC1_Gain=0xFF,Flags;
int				SampleCounter,RxBuffer;
float			Tnum;


/////////////////////////////////////////////////////////////////////////////
//  荞ݏٰ
/////////////////////////////////////////////////////////////////////////////

// USARTM荞ݏٰ
#pragma vector=USART0_RXC_vect
__interrupt void USART0_RXC_ISR(void)
{
	char Status,Data;

	Status=UCSR0A;
	Data=UDR0;
	if ((Status & ((1<<FE0)|(1<<UPE0)|(1<<DOR0)))==0)
	{
		RxBuffer=Data;
		Flags=Flags|KEY_PRESSED;
	}
	else
		RxBuffer=0x00;
}

// USARTM荞ݏٰ
#pragma vector=USART0_TXC_vect
__interrupt void USART0_TXC_ISR(void)
{
	// ɏՂꂽްo͂KvƂꍇɂISRgpĂB
}

// /1ꊄ荞ݏٰ
#pragma vector=TIMER1_OVF_vect
__interrupt void TC1_OVF_ISR(void)
{
	// ͌ċNׂł͂܂B
}

// /1r1v荞ݏٰ(o͂rvŐݒ܂͉܂B)
#pragma vector=TIMER1_COMPA_vect
__interrupt void TC1_COMPA_ISR(void)
{
	// DPCIncrementOC1A鎞0AOC1Aݒ肳鎞1łׂłB
	DisplayCounter=DisplayCounter+DPCIncrement;

	// vg̏ꍇɏo͂̐ݒ܂͉
	if (TC1extTOP>0)
	{
		TC1ext++;								// gvis()
		if (TC1ext<TC1extTOP)					// gv햢TOPɒB
		{
			TCCR1A=(1<<COM1A1)|(0<<COM1A0);		// ̔rvŉo
			DPCIncrement=0;						// ̔rvŕ\v푝Ȃ
		}
		else									// gvTOPB
		{
			if (TC1ext>TC1extTOP)
			{	// o͂ݒ(Ŝ̊Jn)
				TC1ext=0;						// gv
				OCR1A=0xFFFF;					// gꂽTOP܂ŊS16ޯĎv
				TCCR1A=(1<<COM1A1)|(0<<COM1A0);	// ̔rvŉo
				DPCIncrement=0;					// ̔rvŕ\v푝Ȃ
			}
			else
			{	// SĂ16ޯĊSI(csĂ̌ɏo͐ݒ)
				OCR1A=TC1extRem;				// ŏIgv̂߂̎clw
				TCCR1A=(1<<COM1A1)|(1<<COM1A0);	// ̔rvŐݒo
				DPCIncrement=1;					// ̔rvŕ\v푝
			}
		}
	}
	else
	{
		TC1ext=0;
	}

	if (CalCoeff.DPC==DisplayCounter)
	{
		DisplayCounter=0;
		PORTE |= DPP;							// DPPHighݒȀo͂͐Î~̂܂
		DPCActive=1;							// DPP/DPNpvԊJn
	}
}

// /1rBv荞ݏٰ
#pragma vector=TIMER1_COMPB_vect
__interrupt void TC1_COMPB_ISR(void)
{
	unsigned char Temp;

	// OC1AOCR1ArvŐݒAł͂̏o͂
	Temp=TCCR1A;							// ݂ڼ޽lۑ(̔rvŐݒ/?)
	TCCR1A=(1<<COM1A1)|(0<<COM1A0);			// ݒ蓮:rvOC1A
	TCCR1C=(1<<FOC1A);						// ô͉ߒɔrv
	TCCR1A=Temp;							// ݒ蓮:lA(̔rvŐݒ/)
}

// ͑łADC荞ݏٰ
#pragma vector=ADC_vect
__interrupt void ADC_ISR(void)
{
	signed int	TempI;
	signed long	TempL;

	PORTB |= DUTY;					// ޭè يĎp

	// ADC̍̎ް:		ADCW		͈=[0000`03FF]
	// ̎ް̕:			Sample		͈=[0000`03FF]
	// ް̎ړx:	Temp		͈=[00000000`0003FB01]
	// DChgް:			Filtered	͈=[FFFE0280`0001FD80]

	// VNȎ̕ۑB݂̎͋tɂAtɖ߂܂B
	// wWϐ͈ȉ̂悤ɍ̎悳ق̌o܂ێ܂B
	//
	// ISR:			|XXX|  |XXX|  |XXX|  |XXX|  |XXX|  |XXX|  |XXX|  |XXX|  |
	// wW/MUX:	XXX|000000|111111|222222|000000|111111|222222|000000|1111
	// ̎:		|XXXXXX|000000|111111|222222|000000|111111|222222|000000|
	// :		|XXXXXX|XXXXXX|000000|111111|222222|000000|111111|222222|
	// -------------+------+------+------+------+------+------+------+------+--
	// ϊ:		N     N+1    N+2    N+3    N+4    N+5    N+6    N+7    N+8
	//
	Sample[Index].Previous=Sample[Index].Fresh;		// x[n]x[n+1]
	if (0==Index)							// ްx[n]
		Sample[Index].Fresh=ADC;			// d̂܂܂ۑ
	else
		Sample[Index].Fresh=(0x03FF-ADC);	// tɂ݂̎ۑ

	// DCψ(̾)̂߂hgKpBx̂߂longް`gp
	// ΂Ȃ܂!B`B֐͎̒ʂłB
	//
	//	y[n] = 0.996*y[n-1] + 0.996*x[n] - 0.996*x[n-1]
	Sample[Index].PreviousFiltered=Sample[Index].Filtered;	// y[n-1]y[n]
	TempL=255*(long)Sample[Index].Filtered;
	TempL=TempL>>8;
	TempI=Sample[Index].Fresh-Sample[Index].Previous;
	TempL=TempL+255*(long)TempI;
	Sample[Index].Filtered=TempL;

	// M肷܂ŗݒύXȂłB
	if (GainHysteresis)
	{
		Flags=Flags&(0xFF-MOREGAIN0);
		Flags=Flags&(0xFF-MOREGAIN1);
		GainHysteresis--;
	}
	else
		// BwW(Index)=1ADC0,Index=2ADC1
		switch (Index)
		{
			case 1: // ŖOaȂAiK
				if (Sample[Index].Fresh>SAT_HI)
					Flags=Flags|LESSGAIN0;
				// ŖOaȂAiK
				if (Sample[Index].Fresh<SAT_LO)
					Flags=Flags|LESSGAIN0;
				// hgU臒lȏ̏ꍇɗȂB
				if (Sample[Index].Filtered>AMP_LO)
					Flags=Flags&(0xFF-MOREGAIN0);
				break;
			case 2: // ŖOaȂAiK
				if (Sample[Index].Fresh>SAT_HI)
					Flags=Flags|LESSGAIN1;
				// ŖOaȂAiK
				if (Sample[Index].Fresh<SAT_LO)
					Flags=Flags|LESSGAIN1;
				// hgU臒lȏ̏ꍇɗȂB
				if (Sample[Index].Filtered>AMP_LO)
					Flags=Flags&(0xFF-MOREGAIN1);
		}
  
	// ʑZKpBdÂ悤ɘAް يԂɒx܂B
	//
	// 	x = [ 360~f() ] / [ 3~f(̎) ]
	//
	// 2400Hz̎摬xɉāA͗ႦADC0ADC1̐VNȍ̎悪ۂ
	// 1/2400=0.42ms̎ԍAĂꂪ50Hz(50~360)/2400=
	// 7.5ɑΉ邱ƈӖ܂BāA۸ޑO̓dϗ͑
	// \Iɍő6̕tʑx^邩܂Bʑc͈ȉ̂悤
	// ԂpčZ܂B
	//
	//	Calibrated = x[n-1] + CalibCoefficient~( x[n] - x[n-1] )
	//
	// ԂŒ莞ԒxƓł邱ƂɒӂĂB͂荂
	// gmɕ␳ȂƂӖ܂BƂ͌A\IɁAx
	// 󂯓\Ȑȉɉ荂gɉď[ȴ
	// ް݂͑܂B
	//
	// 荂̎摬xɂӂĂBႢ̂́ł̍Z͈͂łB
	// ̎摬xꍇÂ悤ȒԂ͂DCϐdϗ
	// ʑxɑ΂ĕ⏞ł܂B̂悤ȕϗ6𒴂ʑx
	// ܂B
	TempL=Sample[Index].Filtered-Sample[Index].PreviousFiltered;
	TempL=TempL*CalCoeff.PCC[Index];
	TempL=TempL>>16;
	Sample[Index].Calibrated=Sample[Index].Filtered-TempL;

	// SĂقł̓dAdALd͂ɑ΂鑪ްۑBLd͑
	// ΂āAud͐ςvZBdƓd̑ɑ΂āA2vZB
	//
	// ͈͌:
	//
	//	hgް:			Filtered  ͈=[FFFE0280`0001FD80]
	//	Okڂް(>>5):	TempX	  ͈=[FFFFF014`00000FEC]
	//	Z:				(N/A)	  ͈=[FF027E70`00FD8190]
	//
	//	Okڂް(>>6):	TempX	  ͈=[FFFFF80A`000007F6]
	//	Z:				(N/A)	  ͈=[FFC09F9C`003F6064]
	//
	// ̎悵ްSڂŒ~Ɖ肷(ʉhg킪̂悤ȐM0
	// ޲邽߁A͗L蓾Ȃ)AݐϖړIɂɑ΂Đϕ꓾ő厑
	// ͈ȉłB
	//
	//	ő厎(Ok=32) = 7FFFFFFFh / 00FD8190h = 0081h = 129d
	//	ő厎(Ok=64) = 7FFFFFFFh / 003F6064h = 0205h = 517d
	//
	// : wW(Index)=0ADC2, Index=1ADC0, Index=2ADC1
	Temp[Index]=Sample[Index].Calibrated>>6;
	switch (Index)
	{
		case 0: // wW(Index)=0ADC2 (d)
			Accumulator.U2=Accumulator.U2+(Temp[0]*Temp[0]);
			break;
		case 1: // wW(Index)=1ADC0 ((L)d)
			Accumulator.IL2=Accumulator.IL2+(Temp[1]*Temp[1]);
			Temp[3]=Temp[0]*Temp[1];
			Accumulator.PL=Accumulator.PL+Temp[3];
			break;
		case 2: // wW(Index)=2ADC1 ((N)d)
			Accumulator.IN2=Accumulator.IN2+(Temp[2]*Temp[2]);
			Temp[4]=Temp[0]*Temp[2];
			Accumulator.PN=Accumulator.PN+Temp[4];
			SampleCounter++;
			break;
	}
	if (SampleCounter==NMAX)
	{
		SampleCounter=0;
		if (Flags&GROGGY)
		{
			// sݐް
			Accumulator.PL=0;
			Accumulator.PN=0;
			Accumulator.U2=0;
			Accumulator.IL2=0;
			Accumulator.IN2=0;
			Flags=Flags&(0xFF-GROGGY);		// ׸މ(OK)
		}
		else
			Flags=Flags|CYCLE_FULL;
	}

	// ق̑dێ
	if (++Index > 2)
		Index=0;
	ADMUX=ADC_VREF_TYPE+Index;				// ADCّI

	// ȂΕ\vٽێB̂悤ٽݐ؂ւB
	//          ________
	// DPP:  __|        |___________________________________
	//                            ________
	// DPN:  ____________________|        |_________________
	//
	// : --+--------+--------+--------+------------------>
	//         0      DPon    2*DP_ON  3*DP_ON      1T = 1/fs
	//
	// \vdlɏ]ٽݒ肷̂DP_ON萔gpĂB
	if (DPCActive>0)
	{
		DPCActive++;
		switch (DPCActive)
		{
			case DP_ON:    PORTE &= (0xFF-DPP);
				break;
			case 2*DP_ON:  PORTE |= DPN;
				break;
			case 3*DP_ON:  PORTE &= (0xFF-DPN);
				DPCActive=0;
				break;
		}
	}
	PORTB &= (0xFF-DUTY);
	asm("wdr");								// ޯ ؾ
} // ADC_ISR̍Ō

/////////////////////////////////////////////////////////////////////////////
//  ⏕֐
/////////////////////////////////////////////////////////////////////////////

// ɊÂ͗p̊{֐
int getchar(void)
{
	Flags=Flags&(0xFF-KEY_PRESSED);
	return RxBuffer;
}

// ɊÂo(printfȂ)p̊{֐
int putchar(int Data)
{
	while ((UCSR0A & (1<<UDRE0))==0);
	UDR0=Data;
	return(Data);
}

// тɊÂCRC16ьvZBVтԂB
unsigned int CRC(unsigned int chksum, unsigned char buffer)
{
	unsigned char j=8;

	chksum ^= (unsigned int)(buffer);
	do
	{
		if(chksum&0x8000)
			chksum=(chksum<<1) ^ CRC_POLYNOME;
		else
			chksum=chksum<<1;
	}
	while(--j);
	return(chksum);
}

// ޲ ؾČɌĂ΂BlƂKvڼ޽B
void Initialize(void)
{
	ACSR=(1<<ACD);								// ۸ޔr֎~(ߓd)

	DDRB=DIRB;
	DDRE=DIRE;

	TCCR1A=(1<<COM1A1)|(0<<COM1A0);								// (EPo͂ȂɂS炸)̔rvŉo
	TCCR1B=(0<<WGM13)|(1<<WGM12)|(1<<CS12)|(0<<CS11)|(1<<CS10);	// CTC`,Top=OCR1A,CLK/1024
	OCR1A=0xFFFF;												// d0AőٽԊuݒ
	OCR1B=0x00C3;												// EPAT=(1024~195)/4000000=49.92ms
	TIMSK1=(1<<OCIE1B)|(1<<OCIE1A)|(1<<TOIE1);					// T/C1:rAv,rBv,ꊄ荞݋

	UCSR0A=(1<<U2X0);							// USART {싖A۾֎~
	UCSR0B=(1<<RXCIE0)|(1<<TXCIE0)|(1<<RXEN0)|(1<<TXEN0);		// MAM荞݋
	UCSR0C=(1<<UCSZ01)|(1<<UCSZ00);								// 񓯊AèȂA8ޯ ްA1~ޯ
	UBRR0=0x000C;												// f=4.000MHz, U2X=1: 38400ް}0.2%

	// A/Dϊ(ADC):
	// ADC荞݋AREFł̈pݻtdgpBd͂
	// ŏقɐݒ肵AADC̍ɐݒ肵ȂBNAϊ(R
	// s)ɐݒB
	//
	//  fCLK | ADPS | Ou | ADCCLK | ̎摬x
	// ------+------+----------+--------+---------
	// 4.000 |  111 |      128 | 31250  |     2403

	ADMUX=ADC_VREF_TYPE;
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0);	// ADCANA荞݋A128Ou

	Flags=Flags|DISPLAY;					// ׸ސݒ
	Flags=Flags|GROGGY;						// Nオ蒼Abێ
	TC1extTOP=0xFFFF;						// d0ƉAő吔ݒ
	DPCIncrement=0;							// \vٽȂɂS炸AȂ

	SampleCounter=-1200+NMAX;				// 1%ȓւ̈HPFɋB
	PORTB |= EARTH|REVDIR;					// ŊJn邽߂ɐMHighɐݒ
}

void InitGainControl(void)
{
	// LessGain׸ނ͉ꂩ̎ɒBɐݒ肳܂B
	Flags=Flags&(0xFF-LESSGAIN0);
	Flags=Flags&(0xFF-LESSGAIN1);

	// MoreGain׸ނ͉ꂩ̎臒lɒBɉ܂B
	Flags=Flags|MOREGAIN0;
	Flags=Flags|MOREGAIN1;
}

void ReadCalibration(void)
{
	// EEPROMɊ荞݂֎~Ȃ΂ȂȂƂĒuĂ!B
	//
	// ڽ | +0x00 | +0x01 | +0x02 | +0x03 | +0x04 | +0x05 | +0x06 | +0x07
	// -----+-------+-------+-------+-------+-------+-------+-------+-------
	//  0x00 | PCC0H | PCC0L | PCC1H | PCC1L | PCC2H | PCC2L | ILG0H | ILG0L
	//  0x08 | ILG1H | ILG1L | ILG2H | ILG2L | ING0H | ING0L | ING1H | ING1L
	//  0x10 | ING2H | ING2L |   UGH |   UGL |   MCH |   MCL |  DPCH |  DPCL
	//  0x18 |       |       |       |       | CRCWH | CRCWL | CRC16 | CRC16
	//
	// L:LтƖȍZv^邽߁AEEPROM0ŖȂł!B

	unsigned char n=0,Hi,Lo;
	unsigned int crc=0;

	// EEPROM̐擪24޲Ăɑ΂ьvZ
	for (n=0;n<0x18;n++)
	{
		__EEGET(Hi,n);
		crc = CRC(crc,Hi);
	}

	// CRC2=$4357ȂтEEPROMɏ
	__EEGET(Hi,0x1C);
	if (0x43==Hi)
	{
		__EEGET(Lo,0x1D);
		if (0x57==Lo)
		{
			__EEPUT(0x1C,0x00);
			__EEPUT(0x1D,0x00);
			__EEPUT(0x1E,(crc>>8));
			__EEPUT(0x1F,(crc&0xFF));
		}
	}

	// ѕێȂAEEPROMZvǂݍ
	__EEGET(Hi,0x1E);
	__EEGET(Lo,0x1F);
	if (crc-(Hi<<8)-Lo)
	{
		// ُ폈ɒuĂB
	}
	else
	{
		for (n=0;n<3;n++)
		{
			__EEGET(Hi,0x00 + n*2);
			__EEGET(Lo,0x01 + n*2);
			CalCoeff.PCC[n]=(Hi<<8) + Lo;

			__EEGET(Hi,0x06 + n*2);
			__EEGET(Lo,0x07 + n*2);
			CalCoeff.ILG[n]=1.0 / ((Hi<<8) + Lo);

			__EEGET(Hi,0x0C + n*2);
			__EEGET(Lo,0x0D + n*2);
			CalCoeff.ING[n]=1.0 / ((Hi<<8) + Lo);
		}

		__EEGET(Hi,0x12);
		__EEGET(Lo,0x13);
		CalCoeff.UG=(unsigned int)((Hi<<8) + Lo) / 65536.0;

		__EEGET(Hi,0x14);
		__EEGET(Lo,0x15);
		CalCoeff.MC=(Hi<<8) + Lo;

		__EEGET(Hi,0x16);
		__EEGET(Lo,0x17);
		CalCoeff.DPC=(Hi<<8) + Lo;
	}

	// ۯߖ:qvZAEP T/C␳̎c:
	//
	//   Tnum = (3600~fCLK)/(Ou~P[kW])
	//        = (3600~4000000~1000)/(1024~MC)
	//        = 14 062 500 000 / MC
	Tnum=14062500000.0/CalCoeff.MC;
}

void SetGain(unsigned char Channel, unsigned char Level)
{
	//  ADC |        |      |    PE    |   PORTE  |   DDRE
	//  Ch. |  Range | Gain | 76543210 | 76543210 | 76543210
	// -----+--------+------+----------+----------+----------
	//   0  |    Low |    1 | xxxxLLxx | xxxx00xx | xxxx11xx
	//   0  | Medium |    8 | xxxxHLxx | xxxx10xx | xxxx11xx
	//   0  |   High |   64 | xxxxLHxx | xxxx01xx | xxxx11xx
	//   1  |    Low |    1 | xxLLxxxx | xx00xxxx | xx11xxxx
	//   1  | Medium |    8 | xxHLxxxx | xx10xxxx | xx11xxxx
	//   1  |   High |   64 | xxLHxxxx | xx01xxxx | xx11xxxx

	#define GC0 ((1<<PE3)|(1<<PE2))
	#define GC1 ((1<<PE5)|(1<<PE4))

	switch (Level)
	{
		case LOW:	switch (Channel)
			{
				case ADC0: // (PE2=LPE3=L)ɐݒ
					PORTE &= (0xFF-GC0);
					ADC0_Gain=LOW;
					break;
				case ADC1: // (PE4=LPE5=L)ɐݒ
					PORTE &= (0xFF-GC1);
					ADC1_Gain=LOW;
					break;
			}
			break;
		case MEDIUM:  switch (Channel)
			{
				case ADC0: // PE2=LPE3=Hɐݒ
					PORTE = PORTE & (0xFF-GC0) | (1<<PE3);
					ADC0_Gain=MEDIUM;
					break;
				case ADC1: // PE4=LPE5=Hɐݒ
					PORTE = PORTE & (0xFF-GC1) | (1<<PE5);
					ADC1_Gain=MEDIUM;
					break;
			}
			break;
		case HIGH:	  switch (Channel)
			{
				case ADC0: // PE2=HPE3=Lɐݒ
					PORTE = PORTE & (0xFF-GC0) | (1<<PE2);
					ADC0_Gain=HIGH;
					break;
				case ADC1: // PE4=HPE5=Lɐݒ
					PORTE = PORTE & (0xFF-GC1) | (1<<PE4);
					ADC1_Gain=HIGH;
					break;
			}
			break;
	}
	GainHysteresis=GAIN_HOLD;
}

void SetPulse(float Power)
{
	// ȉ̂悤ɴٷް ٽ̏o͎gݒ
	//
	//        fCLK       3600
	//  T = --------~----------
	//      Ou   P[kW]~MC
	//
	// 4MHz̼ ۯ1024OułBv萔(MC)10000ٽ/kWh
	// łB
	//
	// ٷް ٽo͂͑Ouꂽ ۯɂċ쓮ʰ޳T/Cɂ
	// Đ䂳܂B̐ݒgpāAT/Co͈͂ȉ̂߂0.2%(
	// 1/500)ɑ΂ėǍDłB
	//
	//  Tmin = 14062500000 / (265V~10A~10000imp/kWh) = 530
	//
	// T/C1ɉ16ޯĂȂ̂ŁAv̂߂̊gTC1extŊi[
	// ܂Bgꂽv͈ȉ̍őٽ܂B
	//
	//        Ou
	// Tmax = --------~( FFFF~FFFF + FFFF ) = >1Ms = >305h = >12d
	//          fCLK
	//
	// AۖƂėLd͂0I_MIN~Unom̂ǂ炩łB
	// I_MIN = 0.002Unom = 230Včv萔Ɖ肷ƁA
	//
	//         4000000              3600
	//  Tmax = -------~--------------------------- = 3057s = <1h
	//          1024    0.002A~230V~10000 imp/kWh

	#define Tmax 0xFFFE0000

	float T;
	unsigned int CtrTemp,ExtCtrTemp;
	char Mask;

	Power=fabs(Power);						// ٽԊu͕܂݂܂B
	if (Power<0.0001)						// 0ł̏Z̗͂̈Œ`܂B
		T=Tmax;
	else
		T=Tnum/Power;						// \ߌvZꂽqܯ(W)ł̓d͂Ƃ̉łB

	if (T<(2*OCR1B))
		T=2*OCR1B;							// ŏԊu=ٽHighԂ2{

	if (T>Tmax)
	{
		ExtCtrTemp=0xFFFF;					// őv
		CtrTemp=0xFFFF;						// őv
	}
	else
	{
		ExtCtrTemp=T/0xFFFF;				// 16ޯČv
		CtrTemp=T-(ExtCtrTemp*0xFFFF);		// P/ŏIł̌v
	}

	Mask=TIMSK1;
	TIMSK1=0x00;							// uԓIT/C1荞݋֎~

	if (TC1extTOP>0)
	{	// ݌v͊gv̒
		TC1extTOP=ExtCtrTemp;				// gv̂߂ɐVTOPlݒ
		if (TC1ext>TC1extTOP)
			TC1ext=TC1extTOP;				// VgŌvl킹B
		if (TC1ext==TC1extTOP)
		{	// ŏIgv
			OCR1A=CtrTemp;					// ŏIpTOPlݒ
			TCCR1A=(1<<COM1A1)|(1<<COM1A0);	// `Ԑݒ:̔rvOC1Aݒ
			DPCIncrement=1;					// ̔rvŕ\vis()sB
		}
		else
		{	// i߂邽߂ɏȂĂ1ȏ̊g
			OCR1A=0xFFFF;					// ŏIpTOPlݒ
			TCCR1A=(1<<COM1A1)|(0<<COM1A0);	// `Ԑݒ:̔rvOC1Aݒ
			DPCIncrement=0;					// ̔rvŕ\vis()sB
		}
	}
	else
	{	// ݌v킪\ʑs
		OCR1A=CtrTemp;						// VTOPlݒ
		if (ExtCtrTemp>0)
		{	// ͊gđsȂ΂Ȃ܂B
			TC1extTOP=ExtCtrTemp;			// gvpTOPlݒ
			TC1ext=TC1extTOP;				// g̍Ōł̂悤ɑ
		}
		TCCR1A=(1<<COM1A1)|(1<<COM1A0);		// `Ԑݒ:̔rvOC1Aݒ
		DPCIncrement=1;						// ̔rvŕ\vis()sB
	}
	TC1extRem=CtrTemp;						// ̍ŏIpTOPlݒ
	unsigned char tempTCNT1 = TCNT1;		// ifxɋAꍇ2ڼ޽ ̂߁Aɓǂ݂ƂKv
	if (tempTCNT1>=OCR1A)
		TCNT1=(OCR1A-1);					// v킪TOP傫΁A߂

	TIMSK1=Mask;							// T/C1荞ݕ()
}

/////////////////////////////////////////////////////////////////////////////
//  ٰ
/////////////////////////////////////////////////////////////////////////////

void TestLCD(void);
void TestLCD(void)
{
	LCD_Init();
	LCD_ClearAllButArrowsAndBatt();

	LCD_SetArrow(1);
	LCD_SetArrow(2);
	LCD_SetArrow(3);
	LCD_SetArrow(4);
	LCD_SetArrow(5);
	LCD_SetArrow(6);

	LCD_ClrArrow(1);
	LCD_ClrArrow(2);
	LCD_ClrArrow(3);
	LCD_ClrArrow(4);
	LCD_ClrArrow(5);
	LCD_ClrArrow(6);

	LCD_SetDigit(0,1);
	LCD_SetDigit(1,1);
	LCD_SetDigit(2,1);
	LCD_SetDigit(3,1);
	LCD_SetDigit(4,1);
	LCD_SetDigit(5,1);
	LCD_SetDigit(6,1);
	LCD_SetDigit(7,1);
	LCD_SetDigit(8,1);
	LCD_SetDigit(9,1);

	LCD_SetCharacter('a',2);
	LCD_SetCharacter('B',3);
	LCD_SetCharacter('c',4);
	LCD_SetCharacter('D',5);

	for (;;) {}
}

void main(void)
{
	unsigned long	TempUL;

	// ؾČ
	if (MCUSR & (1<<PORF))									// dONؾ
	{
		// KvȂ΁AɓdONؾďuĂB
	}
	else if (MCUSR & (1<<EXTRF))							// Oؾ
	{
		// KvȂ΁AɊOؾďuĂB
	}
	else if (MCUSR & (1<<BORF))								// do(BOD)ؾ
	{
		// KvȂ΁Aɒdo(BOD)ؾďuĂB
	}
	else if (MCUSR & (1<<WDRF))								// ޯ ؾ
	{
		// KvȂ΁Aɳޯ ؾďuĂB
	}
	else
	{
		// KvȂ΁Aɑؾď(ႦJTAGؾ)uĂB
	}
	MCUSR=0;

	Initialize();											// I/Oڼ޽A׸ށAϐ\ݒ
	ReadCalibration();										// 荞݂EEPROMɋ֎~Ȃ΂Ȃ܂B
	InitGainControl();										// ϐ`Ԑݒ
	SetGain(ADC0,LOW);										// ᗘJn
	SetGain(ADC1,LOW);										// ᗘJn

	asm("wdr");												// ޯތvؾ
	WDTCR |= (1<<WDCE) | (1<<WDE);							// ޯފ荞݋
	WDTCR = (1<<WDE) | (1<<WDP2) | (1<<WDP1) | (0<<WDP0);	// 128K(1.0s)ݒ
	asm("sei");												// S̊荞݋

	printf("\n\r");
	printf("AVR465\n\r");
	printf("\n\r");
	printf("PCC:   0x%04X   0x%04X   0x%04X\n\r",CalCoeff.PCC[0],CalCoeff.PCC[1],CalCoeff.PCC[2]);
	printf("ILG: %8.6f %8.6f %8.6f\n\r",CalCoeff.ILG[0],CalCoeff.ILG[1],CalCoeff.ILG[2]);
	printf("ING: %8.6f %8.6f %8.6f\n\r",CalCoeff.ING[0],CalCoeff.ING[1],CalCoeff.ING[2]);
	printf("UG:  %8.6f\n\r",CalCoeff.UG);
	printf("MC:  %8u\n\r",CalCoeff.MC);
	printf("DPC: %8u\n\r",CalCoeff.DPC);
	printf("\n\r");

	while (1)
	{
		if (Flags&KEY_PRESSED)
		{
			// ŷ֐}
			switch (getchar())
			{
				case 'd':
				case 'D':
					if (Flags&DISPLAY)
						Flags=Flags&(0xFF-DISPLAY);
					else
						Flags=Flags|DISPLAY;
					break;
			}
	}

		// ް̊SȎ񂪗ݐςꂽAꂪ̍̎掖ɂď㏑
		// Oɗݐςꂽް̕܂Bݐςꂽްȉ̂悤ɏ
		// ܂B
		//
		// Ld:	P = (ݐް) / ()
		// d:		U = SQRT [ (ݐް) / () ]
		// d:		I = SQRT [ (ݐް) / () ]
		// 瑊d:	S = U~I
		//
		// SĂް͎̗ݐώ񂪊OɊȂ΂Ȃ܂B
		if (Flags&CYCLE_FULL)
		{
			Flags=Flags&(0xFF-CYCLE_FULL);

			// ꂪ㏑Oɗݐް̕쐬
			Sum=Accumulator;

			// ݐް
			Accumulator.PL=0;
			Accumulator.PN=0;
			Accumulator.U2=0;
			Accumulator.IL2=0;
			Accumulator.IN2=0;

			// ްŎgpꂽݒۑ
			Result.ADC0_Gain=ADC0_Gain;
			Result.ADC1_Gain=ADC1_Gain;

			// ̑̑gpɐݒ
			if (Flags&LESSGAIN0)
				switch (ADC0_Gain)
				{
					case MEDIUM:
						SetGain(ADC0,LOW);
						break;
					case HIGH:
						SetGain(ADC0,MEDIUM);
						break;
				}
			if (Flags&MOREGAIN0)
				switch (ADC0_Gain)
				{
					case LOW:
						SetGain(ADC0,MEDIUM);
						break;
					case MEDIUM:
						SetGain(ADC0,HIGH);
						break;
				}
			if (Flags&LESSGAIN1)
				switch (ADC1_Gain)
				{
					case MEDIUM:
						SetGain(ADC1,LOW);
						break;
					case HIGH:
						SetGain(ADC1,MEDIUM);
						break;
				}
			if (Flags&MOREGAIN1)
				switch (ADC1_Gain)
				{
					case LOW:
						SetGain(ADC1,MEDIUM);
						break;
					case MEDIUM:
						SetGain(ADC1,HIGH);
						break;
				}

			InitGainControl();

			// vZBLd͂Ɗƒɑ΂d𓱂o߂ɗݐް
			// gp܂B܂ƒԂ̓do܂B

			// ݐްɕψ(̾)ǉ邱ƂɂĊJn܂B͏
			// ȐUŔ񒼐P܂Bψʂ[ɏ΁A͂
			// ł!B
			if (Sum.PL>0)
				Result.PL=Sum.PL*NORM+OFFSET;
			else
				Result.PL=Sum.PL*NORM-OFFSET;
			if (Sum.PN>0)
				Result.PN=Sum.PN*NORM+OFFSET;
			else
				Result.PN=Sum.PN*NORM-OFFSET;
			TempUL=(Sum.U2+OFFSET)*NORM;
			Result.U=sqrt(TempUL);
			TempUL=(Sum.IL2+OFFSET)*NORM;
			Result.IL=sqrt(TempUL);
			TempUL=(Sum.IN2+OFFSET)*NORM;
			Result.IN=sqrt(TempUL);

			// ZB茋ʂƎĂ̓v̓ɏ]ĕ␳܂B
			Result.PL=Result.PL*CalCoeff.ILG[Result.ADC0_Gain];
			Result.IL=Result.IL*CalCoeff.ILG[Result.ADC0_Gain];
			Result.PN=Result.PN*CalCoeff.ING[Result.ADC1_Gain];
			Result.IN=Result.IN*CalCoeff.ING[Result.ADC1_Gain];
			Result.PL=Result.PL*CalCoeff.UG;
			Result.PN=Result.PN*CalCoeff.UG;
			Result.U=Result.U*CalCoeff.UG;

			// sh~:d臒lȉ̎ɓd͓ǂݎؾĂ܂B͐M
			// Ⴗ鎞ٽSoȂƂۏ؂邱ƂłB
			// قł̎Gɑ΂Čڋqɐ߂Ȃ...?
			if (Result.IL<I_MIN)
				Result.PL=0.0;
			if (Result.IN<I_MIN)
				Result.PN=0.0;

			// Ld͂ǂł臒lȏ̎Ɋɂ銱_B
			// ͔ɒႢd͓ǂݎłON/OFFɂȂ銱wh~
			// ƂłB
			if ((fabs(Result.PL)>P_MIN) | (fabs(Result.PN)>P_MIN))
			{
				// nAƁAoRׂ֍sA܂oRŖ
				// SĂ̓d؁BɏՎŵ͎悤ɐݒ肵܂B
				//
				//    EARTH | 
				//   -------+-------------------------------------------
				//     Low  | P(L)P(N)͑傫ɉĖwǓ
				//    High  | P(L)P(N)͑傫ɉēłȂ
				//
				// gp҂ƒꍇA͏dvł͂܂B
				// (ٷް ٽo)ɊւĂ͑傫ȓd͓ǂݎgp܂B
				if (fabs(Result.PL)>fabs(Result.PN))
				{	// |P(L)| > |P(N)|
					if (fabs(Result.PL)>(1.05*fabs(Result.PN)))
						PORTB |= EARTH;			// 傫̍>5%Highݒ
					else
						PORTB &= (0xFF-EARTH);	// 傫̍<5%Lowݒ
					SetPulse(Result.PL);		// gp
				}
				else
				{	// |P(L)| < |P(N)|
					if (fabs(Result.PN)>(1.05*fabs(Result.PL)))
						PORTB |= EARTH;		// 傫̍>5%Highݒ
					else
						PORTB &= (0xFF-EARTH);	// 傫̍<5%Lowݒ
					SetPulse(Result.PN);				// gp
				}

				// Ӑ}ł̓d̗؁B݌vӐ}悤ɔz
				// ĂȂAƒ̗̓dBȉ̂悤Ɋ
				// wݒ肵܂B
				//
				//   REVDIR | 
				//   -------+--------------------------------------
				//     Low  | P(L)AP(N)
				//    High  | P(L)A܂P(N)
				//
				// 萸x͓d̕ɂĉeyڂ܂B
				if ((Result.PL<0) | (Result.PN<0))
					PORTB |= REVDIR;			// d̗NGHighݒ
				else
					PORTB &= (0xFF-REVDIR);		// d̗OKLowݒ
			}
			else
			{
				// _͍֎~܂B
				PORTB &= (0xFF-EARTH);
				PORTB &= (0xFF-REVDIR);
				SetPulse(Result.PL);			// 
			}

			//
			// Ǝްƕ\o̺͂ނɑ}ĂB
			//

			// 茋ʕ\Bꂩ̒[ĳ܂͉pTxDRxDڑĂ
			// BZꂽȂAo͂ܯ(W)ł̗Ld́A߱(A)
			// ł̓dA(V)ł̓dł傤B
			if (Flags&DISPLAY)
			{
				printf(" %12.3f, %12.3f",Result.PL,Result.PN);
				printf(", %10.5f, %10.5f",Result.IL,Result.IN);
				printf(", %8.3f",Result.U);
				printf("\n\r");
			}
		}
	}
}
